
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Module executionManager &#8212; pyNumericalTrials 0.1.0 documentation</title>
    <link rel="stylesheet" href="_static/alabaster.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <script id="documentation_options" data-url_root="./" src="_static/documentation_options.js"></script>
    <script src="_static/jquery.js"></script>
    <script src="_static/underscore.js"></script>
    <script src="_static/doctools.js"></script>
    <script src="_static/language_data.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Module readNplot" href="readNplot.html" />
    <link rel="prev" title="Module trialManager" href="trialManager.html" />
   
  <link rel="stylesheet" href="_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <div class="toctree-wrapper compound">
</div>
<div class="section" id="module-executionmanager">
<h1>Module executionManager<a class="headerlink" href="#module-executionmanager" title="Permalink to this headline">¶</a></h1>
<dl class="simple">
<dt>This module provides tools to manage the following:</dt><dd><ol class="arabic simple">
<li><p>sweeping arguments of expierment scripts through a range of values,</p></li>
<li><p>preforming random sampeling and averaging,</p></li>
<li><p>parallelization of 1) and 2),</p></li>
<li><p>saving results to a file.</p></li>
</ol>
</dd>
</dl>
<div class="section" id="managing-execution">
<h2>Managing Execution<a class="headerlink" href="#managing-execution" title="Permalink to this headline">¶</a></h2>
<p>The first three goals are accomplished by first adding three arguments to experiment script:</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span><span class="s1">&#39;--sweepfile&#39;</span><span class="p">,</span> <span class="n">default</span><span class="o">=</span><span class="s1">&#39;sweepfile.csv&#39;</span><span class="p">,</span> <span class="n">help</span> <span class="o">=</span> <span class="s1">&#39;file describing which parameters to sweep&#39;</span><span class="p">)</span>
<span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span><span class="s1">&#39;--nDisorders&#39;</span><span class="p">,</span> <span class="nb">type</span> <span class="o">=</span> <span class="nb">int</span><span class="p">,</span> <span class="n">default</span><span class="o">=</span><span class="mi">100</span><span class="p">,</span> <span class="n">help</span> <span class="o">=</span> <span class="s1">&#39;Number of random samples. Set to one to avoid disorder averaging&#39;</span><span class="p">)</span>
<span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span><span class="s1">&#39;--CPUs&#39;</span><span class="p">,</span> <span class="nb">type</span> <span class="o">=</span> <span class="nb">int</span><span class="p">,</span> <span class="n">default</span><span class="o">=</span><span class="mi">4</span><span class="p">,</span> <span class="n">help</span> <span class="o">=</span> <span class="s1">&#39;number of CPUs to USE&#39;</span><span class="p">)</span>
</pre></div>
</div>
<p>and then using an executionManager object to execute a function of the form compute_point(args, datadir):</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="k">if</span> <span class="vm">__name__</span> <span class="o">==</span> <span class="s1">&#39;__main__&#39;</span><span class="p">:</span>
   <span class="n">dataLoc</span><span class="p">,</span> <span class="n">args</span> <span class="o">=</span> <span class="n">trialInitser</span><span class="o">.</span><span class="n">parseNadd</span><span class="p">()</span>

   <span class="n">dnsCTRL</span> <span class="o">=</span> <span class="n">em</span><span class="o">.</span><span class="n">executionManager</span><span class="p">(</span><span class="n">args</span><span class="p">,</span> <span class="n">dataLoc</span><span class="p">,</span> <span class="n">compute_point</span><span class="p">)</span>
   <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Executing...&quot;</span><span class="p">)</span>
   <span class="n">dnsCTRL</span><span class="o">.</span><span class="n">executeParallel</span><span class="p">()</span>

   <span class="n">trialInitser</span><span class="o">.</span><span class="n">finalize</span><span class="p">()</span>
</pre></div>
</div>
<p>Here <a class="reference internal" href="#pyNumericalTrials.executionManager.executionManager.executeParallel" title="pyNumericalTrials.executionManager.executionManager.executeParallel"><code class="xref py py-func docutils literal notranslate"><span class="pre">executeParallel</span></code></a>, prepares a sequence of args based on what is specified in the sweepfile and in the number of disorders, and executes them in parallel using args.CPUs number of processors. compute_point can then save the result in the datadir for each computation done on the various arguments and disorders. The sweep file specifies how arguments are swept by</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">lin</span><span class="p">,</span> <span class="n">example3</span><span class="p">,</span>   <span class="mi">0</span><span class="p">,</span> <span class="mi">10</span><span class="p">,</span>  <span class="mi">4</span>
<span class="n">log</span><span class="p">,</span> <span class="n">example2</span><span class="p">,</span>   <span class="o">-</span><span class="mi">1</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span>  <span class="mi">4</span>
</pre></div>
</div>
<p>where each line specifies which argument is swept, if the sweep is linear (‘lin’) or logrithmic (‘log’), the start value, the end value, and the number of steps in the sweep.</p>
</div>
<div class="section" id="saving-and-averaging-data">
<h2>Saving and Averaging Data<a class="headerlink" href="#saving-and-averaging-data" title="Permalink to this headline">¶</a></h2>
<p>Having compute_point save the data results is often tedious as it later requires disorder averaging.  Therefore, this module also provides functionality to disorder average and save the data in a sql database.  The <code class="xref py py-mod docutils literal notranslate"><span class="pre">readNplot</span></code> module then provides tools for reading and plotting data from the sql database. To use this feature, the user defined function compute_point(args, datadir) must return a dictionary in a form specified by a “result_format” dictonary which has the same keys as the results dictonary, but the values specify the dimension of the data</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="c1"># integer is dimention of data: currently only up to 2D</span>
<span class="n">results_format</span> <span class="o">=</span> <span class="p">{</span><span class="s1">&#39;mean&#39;</span><span class="p">:</span> <span class="mi">0</span><span class="p">,</span> <span class="s1">&#39;var&#39;</span><span class="p">:</span> <span class="mi">0</span><span class="p">,</span> <span class="s1">&#39;trace&#39;</span><span class="p">:</span> <span class="mi">1</span><span class="p">,</span> <span class="s1">&#39;twoDdata&#39;</span><span class="p">:</span> <span class="mi">2</span><span class="p">}</span>

<span class="k">def</span> <span class="nf">compute_point</span><span class="p">(</span><span class="n">args</span><span class="p">,</span> <span class="n">dataLoc</span><span class="p">):</span>
   <span class="c1"># do computation</span>
   <span class="n">x</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">random</span><span class="o">.</span><span class="n">rand</span><span class="p">(</span><span class="mi">1</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span><span class="o">*</span><span class="n">args</span><span class="o">.</span><span class="n">example3</span>
   <span class="c1"># return &quot;results dictionary&quot;</span>
   <span class="k">return</span> <span class="p">{</span><span class="s1">&#39;mean&#39;</span><span class="p">:</span><span class="n">x</span><span class="p">,</span>
            <span class="s1">&#39;var&#39;</span><span class="p">:</span><span class="n">x</span><span class="o">*</span><span class="n">x</span><span class="p">,</span>
            <span class="s1">&#39;trace&#39;</span><span class="p">:</span> <span class="n">np</span><span class="o">.</span><span class="n">linspace</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span><span class="mi">10</span><span class="o">*</span><span class="n">x</span><span class="p">,</span><span class="mi">5</span><span class="p">),</span>
            <span class="s1">&#39;twoDdata&#39;</span><span class="p">:</span> <span class="n">np</span><span class="o">.</span><span class="n">outer</span><span class="p">(</span><span class="nb">range</span><span class="p">(</span><span class="mi">10</span><span class="p">),</span><span class="nb">range</span><span class="p">(</span><span class="mi">10</span><span class="p">))</span>
         <span class="p">}</span>
</pre></div>
</div>
<p>Both the results_format variable and compute_point function are passed to the constructor for the <a class="reference internal" href="#pyNumericalTrials.executionManager.executionManager" title="pyNumericalTrials.executionManager.executionManager"><code class="xref py py-class docutils literal notranslate"><span class="pre">executionManager</span></code></a> object, and the <a class="reference internal" href="#pyNumericalTrials.executionManager.executionManager.averageNSave" title="pyNumericalTrials.executionManager.executionManager.averageNSave"><code class="xref py py-func docutils literal notranslate"><span class="pre">averageNSave</span></code></a> function is called in addition to the <a class="reference internal" href="#pyNumericalTrials.executionManager.executionManager.executeParallel" title="pyNumericalTrials.executionManager.executionManager.executeParallel"><code class="xref py py-func docutils literal notranslate"><span class="pre">executeParallel</span></code></a> function:</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="k">if</span> <span class="vm">__name__</span> <span class="o">==</span> <span class="s1">&#39;__main__&#39;</span><span class="p">:</span>
   <span class="n">dataLoc</span><span class="p">,</span> <span class="n">args</span> <span class="o">=</span> <span class="n">trialInitser</span><span class="o">.</span><span class="n">parseNadd</span><span class="p">()</span>

   <span class="n">dnsCTRL</span> <span class="o">=</span> <span class="n">em</span><span class="o">.</span><span class="n">executionManager</span><span class="p">(</span><span class="n">args</span><span class="p">,</span> <span class="n">dataLoc</span><span class="p">,</span> <span class="n">compute_point</span><span class="p">,</span> <span class="n">results_format</span><span class="p">)</span>
   <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Executing...&quot;</span><span class="p">)</span>
   <span class="n">dnsCTRL</span><span class="o">.</span><span class="n">executeParallel</span><span class="p">()</span>
   <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Saving...&quot;</span><span class="p">)</span>
   <span class="n">dnsCTRL</span><span class="o">.</span><span class="n">averageNSave</span><span class="p">(</span><span class="n">sqlSave</span> <span class="o">=</span> <span class="kc">True</span><span class="p">)</span>

   <span class="n">trialInitser</span><span class="o">.</span><span class="n">finalize</span><span class="p">()</span>
</pre></div>
</div>
<p>A complete example is given in the Examples/ExecutionNDataExamples folder.</p>
</div>
<div class="section" id="executionmanager-class">
<h2>executionManager Class<a class="headerlink" href="#executionmanager-class" title="Permalink to this headline">¶</a></h2>
<dl class="py class">
<dt id="pyNumericalTrials.executionManager.executionManager">
<em class="property">class </em><code class="sig-prename descclassname">pyNumericalTrials.executionManager.</code><code class="sig-name descname">executionManager</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">args</span></em>, <em class="sig-param"><span class="n">dataLocBase</span></em>, <em class="sig-param"><span class="n">compute_point</span></em>, <em class="sig-param"><span class="n">results_format</span><span class="o">=</span><span class="default_value">{}</span></em>, <em class="sig-param"><span class="n">result_keys</span><span class="o">=</span><span class="default_value">[]</span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.executionManager.executionManager" title="Permalink to this definition">¶</a></dt>
<dd><p>This class manages parellel execution for disorder averaging and sweeping a set of arguments.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>args</strong> – args parsed by Args parse</p></li>
<li><p><strong>dataLocBase</strong> – path to where to store data (without ending ‘/’) I’m sorry for having chosen this convension :(</p></li>
<li><p><strong>compute_point</strong> – function with format compute_point(args, swept_arg_names)-&gt;dictionary with keys given by result_keys</p></li>
<li><p><strong>result_keys</strong> – list giving names of results (optional if order of keys is important in saving a csv file)</p></li>
<li><p><strong>result_keys_format</strong> – dictionary with result_keys as the keys, and 0,1,2 and values giving dimention of array for that result.</p></li>
</ul>
</dd>
</dl>
<dl class="simple">
<dt>The arguments to be swept are given in a seperate file specified by</dt><dd><p>args.sweepfile</p>
</dd>
</dl>
<p>That file must have the format of a set of lines with entries:</p>
<blockquote>
<div><p>‘linOlog’, ‘argName’ , ‘x0’,  ‘xf’, ‘n’
str      , str       , float, float, int</p>
</div></blockquote>
<p>With this arg, this class generates the set of parameters to sweep over</p>
<p>The function executeParalell() then uses the multiprocessing library
to make calls to the function compute_point, this function should have the form:</p>
<blockquote>
<div><p>compute_point(args, dataDir)</p>
</div></blockquote>
<dl class="simple">
<dt>And it should (if you want to use averageNsave) then return:</dt><dd><p>a dictionary with keys given by result_keys</p>
</dd>
</dl>
<p>The function averageNsave will, if disorder was involved average over the disorder
and then save the file to a csv called PhaseDiagram.csv (only if there are 0D results)  or an sqlDatabase</p>
<p>In this way, a script that uses a single set of parameters acting on a single disorder realization can be turrned in the a multi-core script which averages over the disorder and can sweep any parameter.</p>
<dl class="py attribute">
<dt id="pyNumericalTrials.executionManager.executionManager.args">
<code class="sig-name descname">args</code><a class="headerlink" href="#pyNumericalTrials.executionManager.executionManager.args" title="Permalink to this definition">¶</a></dt>
<dd><p>args parsed by ArgParse</p>
</dd></dl>

<dl class="py attribute">
<dt id="pyNumericalTrials.executionManager.executionManager.dirBase">
<code class="sig-name descname">dirBase</code><a class="headerlink" href="#pyNumericalTrials.executionManager.executionManager.dirBase" title="Permalink to this definition">¶</a></dt>
<dd><p>location where to save data (without ending ‘/’) I’m sorry for having chosen this convension :(</p>
</dd></dl>

<dl class="py attribute">
<dt id="pyNumericalTrials.executionManager.executionManager.compute_point">
<code class="sig-name descname">compute_point</code><a class="headerlink" href="#pyNumericalTrials.executionManager.executionManager.compute_point" title="Permalink to this definition">¶</a></dt>
<dd><p>function with format compute_point(args, swept_arg_names)-&gt;dictionary with keys given by result_keys</p>
</dd></dl>

<dl class="py attribute">
<dt id="pyNumericalTrials.executionManager.executionManager.result_keys">
<code class="sig-name descname">result_keys</code><a class="headerlink" href="#pyNumericalTrials.executionManager.executionManager.result_keys" title="Permalink to this definition">¶</a></dt>
<dd><p>list giving names of results</p>
</dd></dl>

<dl class="py attribute">
<dt id="pyNumericalTrials.executionManager.executionManager.result_keys_format">
<code class="sig-name descname">result_keys_format</code><a class="headerlink" href="#pyNumericalTrials.executionManager.executionManager.result_keys_format" title="Permalink to this definition">¶</a></dt>
<dd><p>dictionary with result_keys as the keys, and 0,1,2 and values giving dimention of array for that result.</p>
</dd></dl>

<dl class="py attribute">
<dt>
<code class="sig-name descname">self.swept_arg_names, self.argValues2DListPseeds, self.argValues2DList</code></dt>
<dd><p>used for parameter sweep.</p>
</dd></dl>

<dl class="py attribute">
<dt id="pyNumericalTrials.executionManager.executionManager.swept_args_format">
<code class="sig-name descname">swept_args_format</code><a class="headerlink" href="#pyNumericalTrials.executionManager.executionManager.swept_args_format" title="Permalink to this definition">¶</a></dt>
<dd><p>dictionary giving data type of parameter being swept.</p>
</dd></dl>

<dl class="py attribute">
<dt id="pyNumericalTrials.executionManager.executionManager.results">
<code class="sig-name descname">results</code><a class="headerlink" href="#pyNumericalTrials.executionManager.executionManager.results" title="Permalink to this definition">¶</a></dt>
<dd><p>list of dictionaries with keys given by result_keys and values in format descirbed by result_keys_format</p>
</dd></dl>

<p class="rubric">Methods</p>
<table class="longtable docutils align-default">
<colgroup>
<col style="width: 10%" />
<col style="width: 90%" />
</colgroup>
<tbody>
<tr class="row-odd"><td><p><a class="reference internal" href="#pyNumericalTrials.executionManager.executionManager.averageNSave" title="pyNumericalTrials.executionManager.executionManager.averageNSave"><code class="xref py py-obj docutils literal notranslate"><span class="pre">averageNSave</span></code></a>([sqlSave])</p></td>
<td><p>Preforms disorder aveage and saves as csv or sql.</p></td>
</tr>
<tr class="row-even"><td><p><a class="reference internal" href="#pyNumericalTrials.executionManager.executionManager.executeParallel" title="pyNumericalTrials.executionManager.executionManager.executeParallel"><code class="xref py py-obj docutils literal notranslate"><span class="pre">executeParallel</span></code></a>()</p></td>
<td><p>executes code in parallel using map_async.</p></td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="py function">
<dt id="pyNumericalTrials.executionManager.executionManager.executeParallel">
<code class="sig-prename descclassname">pyNumericalTrials.executionManager.executionManager.</code><code class="sig-name descname">executeParallel</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">self</span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.executionManager.executionManager.executeParallel" title="Permalink to this definition">¶</a></dt>
<dd><p>executes code in parallel using map_async.</p>
</dd></dl>

<dl class="py function">
<dt id="pyNumericalTrials.executionManager.executionManager.averageNSave">
<code class="sig-prename descclassname">pyNumericalTrials.executionManager.executionManager.</code><code class="sig-name descname">averageNSave</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">self</span></em>, <em class="sig-param"><span class="n">sqlSave</span><span class="o">=</span><span class="default_value">True</span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.executionManager.executionManager.averageNSave" title="Permalink to this definition">¶</a></dt>
<dd><p>Preforms disorder aveage and saves as csv or sql.</p>
<p>sqlSave: bool whether to save in a sql file or a csv file.
Currently, saving to a csv file can only save 0D dimention results.</p>
</dd></dl>

</div>
<div class="section" id="dictionary-and-averaging-tools">
<h2>Dictionary and Averaging Tools<a class="headerlink" href="#dictionary-and-averaging-tools" title="Permalink to this headline">¶</a></h2>
<dl class="py function">
<dt id="pyNumericalTrials.executionManager.dictionaryAvg">
<code class="sig-prename descclassname">pyNumericalTrials.executionManager.</code><code class="sig-name descname">dictionaryAvg</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">listOdics</span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.executionManager.dictionaryAvg" title="Permalink to this definition">¶</a></dt>
<dd><p>averages a list who elements are dictionary, the average is done key by key</p>
</dd></dl>

<dl class="py function">
<dt id="pyNumericalTrials.executionManager.avgKey">
<code class="sig-prename descclassname">pyNumericalTrials.executionManager.</code><code class="sig-name descname">avgKey</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">listOdics</span></em>, <em class="sig-param"><span class="n">key</span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.executionManager.avgKey" title="Permalink to this definition">¶</a></dt>
<dd><p>takes a list and of dictionaries and returns of the average of values specified by a key</p>
</dd></dl>

<dl class="py function">
<dt id="pyNumericalTrials.executionManager.dicToCSV">
<code class="sig-prename descclassname">pyNumericalTrials.executionManager.</code><code class="sig-name descname">dicToCSV</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">listOdics</span></em>, <em class="sig-param"><span class="n">swept_arg_names</span></em>, <em class="sig-param"><span class="n">i_result_keys</span><span class="o">=</span><span class="default_value">[]</span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.executionManager.dicToCSV" title="Permalink to this definition">¶</a></dt>
<dd><p>takes a list of dictionaries with all the same keys and produces a 2D array, where the first index gives a key and the second gives an element in the list of dictionires:
csv[key, dicIdx]</p>
</dd></dl>

</div>
<div class="section" id="internals">
<h2>Internals<a class="headerlink" href="#internals" title="Permalink to this headline">¶</a></h2>
<dl class="py function">
<dt id="pyNumericalTrials.executionManager.stripSeedNcombine">
<code class="sig-prename descclassname">pyNumericalTrials.executionManager.</code><code class="sig-name descname">stripSeedNcombine</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">results</span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.executionManager.stripSeedNcombine" title="Permalink to this definition">¶</a></dt>
<dd><p>takes the results object: (a list of tuples of the form: (seed, sweep_args, results))
removes the seed
and returns a diction including keys for both the results and sweep_args</p>
</dd></dl>

<dl class="py function">
<dt id="pyNumericalTrials.executionManager.averageSeedLabeledList">
<code class="sig-prename descclassname">pyNumericalTrials.executionManager.</code><code class="sig-name descname">averageSeedLabeledList</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">argValues2DList</span></em>, <em class="sig-param"><span class="n">results</span></em>, <em class="sig-param"><span class="n">swept_arg_names</span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.executionManager.averageSeedLabeledList" title="Permalink to this definition">¶</a></dt>
<dd><p>Similar to stripSeedNcombine, but with a disorder average involved</p>
</dd></dl>

<dl class="py function">
<dt id="pyNumericalTrials.executionManager.prep_argSweepCombinations">
<code class="sig-prename descclassname">pyNumericalTrials.executionManager.</code><code class="sig-name descname">prep_argSweepCombinations</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">args</span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.executionManager.prep_argSweepCombinations" title="Permalink to this definition">¶</a></dt>
<dd><p>uses sweep file to generate keys(arg parameters to sweep) and their values
This function uses args.sweepfile to</p>
<blockquote>
<div><ol class="arabic simple">
<li><p>generate a list of args that are sweept: [‘arg1’,’arg2’,…]: swept_arg_names</p></li>
<li><p>generate table of all the different argument combinations: [[arg1,arg2,…]]: argValues2DList</p></li>
<li><p>if disorder average involve, append a seed varible to that table: [[arg1,arg2,…,seed]]: argValues2DListPseeds</p></li>
</ol>
</div></blockquote>
<p>The function will also split the argValueTable</p>
</dd></dl>

<dl class="py function">
<dt id="pyNumericalTrials.executionManager.readSweepFile">
<code class="sig-prename descclassname">pyNumericalTrials.executionManager.</code><code class="sig-name descname">readSweepFile</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">sweepfile</span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.executionManager.readSweepFile" title="Permalink to this definition">¶</a></dt>
<dd><p>sweepfile is a file of lines. Each line describes how to sweep a parameter:
linOlog, argName, x0, xf, n
i.e:
lin, example,   0, 5.32, 100
log, example2, -1, 1,    100
This function reads that file and produces a list of dictionaries for each line</p>
</dd></dl>

<dl class="py function">
<dt id="pyNumericalTrials.executionManager.kernel">
<code class="sig-prename descclassname">pyNumericalTrials.executionManager.</code><code class="sig-name descname">kernel</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">fixed</span></em>, <em class="sig-param"><span class="n">sweep_arg_values</span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.executionManager.kernel" title="Permalink to this definition">¶</a></dt>
<dd><p>this is the kernel for each CPU core, it takes a set of fixed parameters of the form:
–fixed = (args, sweet_arg_names, compute_point, original_sigint_handler)</p>
<blockquote>
<div><p>–currently: original_sigint_handler is ignored
–compute_point: is some function which takes args and swept_arg_names</p>
<p class="attribution">—sweep_arg_values: is different for each core, they are a list of values for th keys in swept_arg_names
both should be lists of same length with 1-1 maping of key-&gt;values</p>
</div></blockquote>
<dl class="simple">
<dt>this function returns a tuple: (seed, sweep_args, results)</dt><dd><p>–sweep_args: is a dictionary which identifies the arugments that were swept and there values corresponding to this result
–results: is a dictionary with keys given by result_keys</p>
</dd>
</dl>
</dd></dl>

</div>
</div>


          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="index.html">pyNumericalTrials</a></h1>








<h3>Navigation</h3>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="trialManager.html">Module trialManager</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">Module executionManager</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#managing-execution">Managing Execution</a></li>
<li class="toctree-l2"><a class="reference internal" href="#saving-and-averaging-data">Saving and Averaging Data</a></li>
<li class="toctree-l2"><a class="reference internal" href="#executionmanager-class">executionManager Class</a></li>
<li class="toctree-l2"><a class="reference internal" href="#dictionary-and-averaging-tools">Dictionary and Averaging Tools</a></li>
<li class="toctree-l2"><a class="reference internal" href="#internals">Internals</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="readNplot.html">Module readNplot</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="index.html">Documentation overview</a><ul>
      <li>Previous: <a href="trialManager.html" title="previous chapter">Module trialManager</a></li>
      <li>Next: <a href="readNplot.html" title="next chapter">Module readNplot</a></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2021, Shane P. Kelly.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 3.2.1</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.12</a>
      
      |
      <a href="_sources/executionManager.rst.txt"
          rel="nofollow">Page source</a>
    </div>

    

    
  </body>
</html>